''************************************
CON

  _clkmode      = xtal1 + pll16x                        ' use crystal x 16
  _xinfreq      = 5_000_000                            ' external xtal is 5 MHz

VAR

   
OBJ
  Clock         : "Clocks"

PUB start
  Clock.start

  cognew(@entry,0)        

DAT           
              org  
entry         or        outa,   txmask          'init tx pin to high output (not sure why)
              or        dira,   PortBits        ' set portbits 2 and 3 & tx_pin as Pin 7 to output 
    '          mov       t22,     #0
              
Main_Loop     test      CONV, ina     wz         'DVALID
       if_nz  jmp       Main_Loop               ' if Test zero, keep looping

              mov       Time,   cnt             
              add       Time,   delay_200       ' pause: to after CONV, based on scope
              waitcnt   Time,   #0              

              mov       txdata,t22
              call      #transmit         
              add       t22,     #1                
              cmp       t22,    #5     wc        
     if_c     jmp       #Main_Loop              
 
test_5        nop                      
              jmp       #test_5

transmit                                       
              or      txdata,   #$100           
              shl     txdata,   #1
              mov     txbits,   #10
              mov     txcnt,    cnt             
               
:bit          test    txdata,   #1       wc      ' output bit
              muxc    outa,     txmask
              add     txcnt,    bitticks         ' ready next cnt
               
:wait         mov     t4,       txcnt            ' check if bit transmit period done
              sub     t4,       cnt
              cmps    t4,       #0           wc
    if_nc     jmp     #:wait
              shr     txdata,#1             
              djnz    txbits,#:bit               ' another bit to transmit?                          
transmit_ret  ret                                ' jump to instr. after call instr.

                 
bitticks      long      348                                   'for 230400.
CONV          long      %00000000_00000000_00000000_00010000  '(P4)  Input  
PortBits      long      %00000000_00000000_00000000_00001001  '(1 is output)   
txmask        long      %00000000_00000000_00000000_00000001  '(P0)  Output
t22           long      0                       ' t2 to hold 0-255 value
Delay_200     long      16000

Time          res       1
t4            res       1
txdata        res       1
txbits        res       1
txcnt         res       1
